package gosdn

import (
	"net/http"
	"testing"
)

func Test_httpApi(t *testing.T) {
	tests := []struct {
		name    string
		request string
		want    *http.Response
		wantErr bool
	}{
		{
			name:    "/livez",
			request: apiEndpoint + "/livez",
			want:    &http.Response{StatusCode: http.StatusOK},
			wantErr: false,
		},
		{
			name:    "/readyz",
			request: apiEndpoint + "/readyz",
			want:    &http.Response{StatusCode: http.StatusOK},
			wantErr: false,
		},
		{
			name:    "/metrics",
			request: apiEndpoint + "/metrics",
			want:    &http.Response{StatusCode: http.StatusOK},
			wantErr: false,
		},
	}
	coreLock.Lock()
	startHttpServer()
	coreLock.Unlock()
	for _, tt := range tests {
		t.Run(tt.name, func(t *testing.T) {
			got, err := http.Get(tt.request)
			if (err != nil) != tt.wantErr {
				t.Errorf("httpApi() error = %v, wantErr %v", err, tt.wantErr)
				return
			}
			if got.StatusCode != tt.want.StatusCode {
				t.Errorf("httpApi() got: %v, want %v", got.StatusCode, tt.want.StatusCode)
			}
		})
	}
}
