package change

import (
	"time"

	ppb "code.fbi.h-da.de/danet/api/go/gosdn/pnd"
	"github.com/google/uuid"
	"github.com/openconfig/ygot/ygot"
)

// Change is an intended change to an OND. It is unique and immutable.
// It has a cuid, a timestamp, and holds both the previous and the new
// state. It keeps track if the state is committed and confirmed. A callback
// exists to acess the proper transport for the changed OND
type Change interface {
	ID() uuid.UUID
	Commit() error
	Confirm() error
	State() ppb.Change_State
	Age() time.Duration
}

// Payload contains two ygot.GoStructs, the first represents the original state
// before the change was applied and the second repesents the modified state.
type Payload struct {
	Original ygot.GoStruct
	Modified ygot.GoStruct
}
