package device

import (
	"code.fbi.h-da.de/danet/gosdn/interfaces/southbound"
	"code.fbi.h-da.de/danet/gosdn/interfaces/transport"
	"github.com/google/uuid"
	"github.com/openconfig/ygot/ygot"
	"google.golang.org/protobuf/proto"
)

// Device represents an Orchestrated Network Device (OND) which is managed by
// nucleus
type Device interface {
	ID() uuid.UUID
	Model() ygot.GoStruct
	Transport() transport.Transport
	Name() string
	SBI() southbound.SouthboundInterface
	ProcessResponse(proto.Message) error
}
