package transport

import (
	"context"

	"code.fbi.h-da.de/danet/gosdn/interfaces/change"

	"github.com/openconfig/ygot/ytypes"
)

// Transport provides an interface for Transport implementations
// like RESTCONF or gnmi
type Transport interface {
	Get(ctx context.Context, params ...string) (interface{}, error)
	Set(ctx context.Context, payload change.Payload) error
	Subscribe(ctx context.Context, params ...string) error
	Type() string
	ProcessResponse(resp interface{}, root interface{}, models *ytypes.Schema) error
}
