package client

import (
	pb "code.fbi.h-da.de/danet/api/go/gosdn/core"
	"google.golang.org/grpc"
)

// CoreClient returns a client for the gRPC Core service. It takes
// the address of the gRPC endpoint and optional grpc.DialOption
// as argument
func CoreClient(addr string, opts ...grpc.DialOption) (pb.CoreClient, error) {
	conn, err := grpc.Dial(addr, opts...)
	if err != nil {
		return nil, err
	}
	return pb.NewCoreClient(conn), nil
}
