package server

import (
	"code.fbi.h-da.de/danet/gosdn/metrics"
	"code.fbi.h-da.de/danet/gosdn/store"
	"github.com/prometheus/client_golang/prometheus"
	log "github.com/sirupsen/logrus"
	"google.golang.org/grpc/codes"
	"google.golang.org/grpc/status"
)

var pndc *store.PndStore

// NorthboundInterface is the representation of the
// gRPC services used provided.
type NorthboundInterface struct {
	Pnd  *pndServer
	Core *core
	Csbi *csbi
}

// NewNBI receives a PndStore and returns a new gRPC *NorthboundInterface
func NewNBI(pnds *store.PndStore) *NorthboundInterface {
	pndc = pnds
	return &NorthboundInterface{
		Pnd:  &pndServer{},
		Core: &core{},
		Csbi: &csbi{},
	}
}

func handleRPCError(labels prometheus.Labels, err error) error {
	log.Error(err)
	return status.Errorf(codes.Aborted, "%v", metrics.HandleError(labels, err, grpcAPIErrorsTotal))
}
