package nucleus

import (
	"github.com/prometheus/client_golang/prometheus"
	"github.com/prometheus/client_golang/prometheus/promauto"
)

var (
	deviceCreationsTotal = promauto.NewCounterVec(
		prometheus.CounterOpts{
			Name: "device_creations_total",
			Help: "Total number of created devices",
		},
		[]string{"type"},
	)

	deviceCreationDurationSecondsTotal = promauto.NewCounterVec(
		prometheus.CounterOpts{
			Name: "device_creation_duration_seconds_total",
			Help: "Total time needed to create devices",
		},
		[]string{"type"},
	)

	deviceCreationDurationSeconds = promauto.NewHistogramVec(
		prometheus.HistogramOpts{
			Name: "device_creation_duration_seconds",
			Help: "Histogram of device creation times",
		},
		[]string{"type"},
	)

	deviceDeletionsTotal = promauto.NewCounterVec(
		prometheus.CounterOpts{
			Name: "device_deletions_total",
			Help: "Total number of deleted devices",
		},
		[]string{"type"},
	)

	deviceDeletionDurationSecondsTotal = promauto.NewCounterVec(
		prometheus.CounterOpts{
			Name: "device_deletion_duration_seconds_total",
			Help: "Total time needed to delete devices",
		},
		[]string{"type"},
	)

	deviceDeletionDurationSeconds = promauto.NewHistogramVec(
		prometheus.HistogramOpts{
			Name: "device_deletion_duration_seconds",
			Help: "Histogram of device deletion times",
		},
		[]string{"type"},
	)
)
